Advanced Wallets - Send to Many
Send coins or tokens to one or more recipients. You can use this endpoint to schedule outgoing transactions in bulk, lowering your aggregate amount of blockchain fees.
Retrieves the private key from KMS using the provided public key, then signs and broadcasts the transaction.
Works with both multisignature and MPC wallets.
Works with most BitGo-supported assets, but currently unavailable for: ALGO, ARBETH, AVAXC, CELO, CELO:CUSD, CSPR, DOT, EOS, HTETH:BGERCH, NEAR, OPETH, STX, TON, TRX, TRX:USDC, XLM, XRP, XTZ
Use this endpoint only with advanced wallets. For other wallet types, use Send to many.
Path Params
-
walletIdstring required -
coinstring required
Body Params
object
-
sourcestring enum requiredThe key to use for signing the transactionuserbackup -
typestring enumRequired for transactions from MPC wallets.transferfillNonceaccelerationaccountSetenabletokentransfertokentrustline -
recipientsarray of objectsrecipients object
-
addressstring requiredDestination address -
amountstring or number requiredThe amount in base units (e.g. satoshis) to send. For doge, only string is allowed.
-
-
pubkeystringPublic key of the key used for signing multisig transactions i.e if source is user, this is the user's public key if source is backup, this is the backup key's public key -
commonKeychainstringFor TSS wallets, this is the common keychain of the wallet, it remains the same whether source is user or backup -
numBlocksnumber(BTC only) The number of blocks required to confirm a transaction. You can usenumBlocksto estimate the fee rate by targeting confirmation within a given number of blocks. If bothfeeRateandnumBlocksare absent, the transaction defaults to 2 blocks for confirmation. Note: ThemaxFeeRatelimits the fee rate generated bynumBlocks. -
feeRatenumberCustom fee rate (in base units) per kilobyte (or virtual kilobyte). For example, satoshis per kvByte. If thefeeRateis less than the minimum required network fee, then the minimum fee applies. For example, 1000 sat/kvByte, a flat 1000 microAlgos, or a flat 10 drops of xrp. For XRP, the actual fee is usually 4.5 times the open ledger fee. Note: ThefeeRateoverrides themaxFeeRateandminFeeRate. -
feeMultipliernumber(UTXO only) Custom multiplier to thefeeRate. The resulting fee rate is limited by themaxFeeRate. For replace-by-fee (RBF) transactions (that includerbfTxIds), thefeeMultipliermust be greater than 1, since it's an absolute fee multiplier to the transaction being replaced. Note: ThemaxFeeRatelimits the fee rate generated byfeeMultiplier. -
maxFeeRatenumber(BTC only) The maximum fee rate (in base units) per kilobyte (or virtual kilobyte). For example, satoshis per kvByte. ThemaxFeeRatelimits the fee rate generated by bothfeeMultiplierandnumBlocks. Note: ThefeeRateoverrides themaxFeeRate. -
minConfirmsnumberThe unspent selection for the transaction will only consider unspents with at least this many confirmations to be used as inputs. Does not apply to change outputs unless used in combination withenforceMinConfirmsForChange. -
enforceMinConfirmsForChangebooleanWhen set to true, will enforce minConfirms for change outputs. Defaults to false. -
targetWalletUnspentsnumberSpecifies the minimum count of good-sized unspents to maintain in the wallet. Change splitting ceases when the wallet hastargetWalletUnspentsgood-sized unspents. Note: Wallets that continuously send a high count of transactions will automatically split large change amounts into multiple good-sized change outputs while they have fewer thantargetWalletUnspentsgood-sized unspents in their unspent pool. Breaking up large unspents helps to reduce the amount of unconfirmed funds in flight in future transactions, and helps to avoid long chains of unconfirmed transactions. This is especially useful for newly funded wallets or recently refilled send-only wallets. -
messagestringOptional metadata (only persisted in BitGo) to be applied to the transaction. Use this to add transaction-specific information such as the transaction's purpose or another identifier that you want to reference later. The value is shown in the UI in the transfer listing page. -
minValuenumber or stringIgnore unspents smaller than this amount of base units (e.g. satoshis). For doge, only string is allowed. -
maxValuenumber or stringIgnore unspents larger than this amount of base units (e.g. satoshis). For doge, only string is allowed. -
sequenceIdstringAsequenceIdis a unique and arbitrary wallet identifier applied to transfers and transactions at creation. It is optional but highly recommended. With asequenceIdyou can easily reference transfers and transactions—for example, to safely retry sending. Because the system only confirms one send request persequenceId(and fails all subsequent attempts), you can retry sending without the risk of double spending. ThesequenceIdis only visible to users on the wallet and is not shared publicly. -
lastLedgerSequencenumber(XRP only) Absolute max ledger the transaction should be accepted in, whereafter it will be rejected -
ledgerSequenceDeltanumber(XRP only) Relative ledger height (in relation to the current ledger) that the transaction should be accepted in, whereafter it will be rejected -
noSplitChangebooleanSettrueto disable automatic change splitting. Also see:targetWalletUnspents -
unspentsarray of strings -
commentstringOptional metadata (only persisted in BitGo) to be applied to the transaction. Use this to add transaction-specific information such as the transaction's purpose or another identifier that you want to reference later. The value is shown in the UI in the transfer listing page. -
otpstringTwo factor auth code to enable sending the transaction. Not necessary if using a long lived access token within the spending limit. -
changeAddressstringSpecifies a custom destination address for the transaction's change output(s) -
allowExternalChangeAddressbooleanFlag for allowing external change addresses -
instantboolean(DASH only) Specifies whether or not to use Dash's "InstantSend" feature when sending a transaction. -
memostringExtra transaction information for CSPR, EOS, HBAR, RUNE, STX, TON, XLM, and XRP. Required for XLM transactions. Note: For XRP this is the destination tag (DT). For CSPR this is the transfer ID. -
transferIdnumberTransfer ID for the transaction -
eip1559object -
gasLimitnumberCustom gas limit to be used for sending the transaction. Only for ETH and ERC20 tokens. -
custodianTransactionIdstringCustodian transaction ID -
noncestring(DOT only) A nonce ID is a number used to protect private communications by preventing replay attacks. This is an advanced option where users can manually input a new nonce value in order to correct or fill in a missing nonce ID value.
Responses
400
Bad Request
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details
404
Not Found
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details
409
Conflict
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details
422
Unprocessable Entity
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details
500
Internal Server Error
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details
501
Not Implemented
Response Body
object
-
errorstring requiredThe error name -
detailsstring requiredError details